import QtQuick 2.6
import QtQuick.Controls 1.4
import ListWrapperModel 1.0

Item {
    id: root
    objectName: "applicationLauncher"

    Button {
        text: "Shuffle"
        onClicked: {
            modelListWrapper.randomize()
        }
    }
    ListWrapperModel {
        id: modelListWrapper
/*        onRowsAboutToBeMoved: {
            console.info("Rows about to be moved", sourceStart, sourceEnd, destinationRow)
        }

        onRowsMoved: {
            console.info("Rows moved", start, end, row)
        }

        onRowsAboutToBeInserted: {
            console.info("Rows about to be inserted", first)
        }

        onRowsInserted: {
            console.info("Rows inserted", first)
        }

        onRowsAboutToBeRemoved: {
            console.info("Rows about to be removed", first, last)
        }

        onRowsRemoved: {
            console.info("Rows removed", first, last)
        }*/
    }

    ListView {
        id: _pathViewApplicationLauncher

        focus: true
        Keys.onLeftPressed: {
            decrementCurrentIndex()
        }

        Keys.onRightPressed: {
            incrementCurrentIndex()
        }

        readonly property int delegateWidth: width / 3

        anchors.fill: parent
        anchors.topMargin: 60

        orientation: ListView.Horizontal

        preferredHighlightBegin: (0.5 * width) - 0.5*delegateWidth
        preferredHighlightEnd: (0.5 * width) + 0.5*delegateWidth

        highlightMoveDuration: 350

        snapMode: ListView.SnapToItem
        flickDeceleration: 5500
        cacheBuffer: visible ? width : 0
        currentIndex: 1

        model: modelListWrapper

        delegate: Item {
            id: delegateRoot
            width: _pathViewApplicationLauncher.delegateWidth
            height: _pathViewApplicationLauncher.height

            Rectangle {
                anchors.fill: parent
                anchors.margins: 8
                border.color: "#ffbb00"
                border.width: isCurrentItem ? 8 : 2
                color: "#200000ff"
                Text {
                    anchors.centerIn: parent
                    color: "#fff"
                    text: internalName
                    font.pixelSize: 40
                }
                Rectangle {
                    y: height * index
                    width: 80
                    height: 40
                    color: "#ffcc80"
                    Text {
                        anchors.fill: parent
                        font.pixelSize: 12
                        verticalAlignment: Text.AlignVCenter
                        horizontalAlignment: Text.AlignHCenter
                        text: "Index: " + index + "<br/>x: " + delegateRoot.x + "<br/>width: " + delegateRoot.width
                    }
                }
            }

            readonly property bool isCurrentItem: ListView.isCurrentItem

            Component.onCompleted: {
                modelListWrapper.performRandomMove()
            }
        } //delegateRoot
    }

    Item {
        id: _rowSlabs
        property int delegateWidth: 80
        width: childrenRect.width
        height: 50

        anchors.horizontalCenter: parent.horizontalCenter

        Repeater {
            width: _rowSlabs.delegateWidth * count
            model: modelListWrapper
            delegate: Rectangle {
                x: width * index
                color: Qt.hsla(1 / (modelListWrapper.count + 1) * modelListWrapper.itemOrder(index), 1.0, 0.7, 1.0)
                width: _rowSlabs.delegateWidth
                height: 50
                border.width: 4
                border.color: _pathViewApplicationLauncher.currentIndex === index ? "#a0f" : "#000"

                Text {
                    anchors.fill: parent
                    anchors.margins: 4
                    text: "<b>I:%1 O:%3</b><br/>%2".arg(index).arg(internalName).arg(modelListWrapper.itemOrder(index))
                }
            }
        }
    }
}
