#pragma once

#include <QAbstractListModel>

class QmlListWrapperModel : public QAbstractListModel
{
    Q_OBJECT
    Q_PROPERTY(int count READ count NOTIFY countChanged)
public:
    enum Role { ObjectRole = Qt::UserRole + 1 };
    QmlListWrapperModel(QObject *parent = nullptr);
    Q_INVOKABLE void performRandomMove();
    Q_INVOKABLE void randomize();
    Q_INVOKABLE int itemOrder(int indexToUse) const;
    int rowCount(const QModelIndex &parent) const override;
    QVariant data(const QModelIndex &index, int role) const override;
    QHash< int, QByteArray > roleNames() const override;
    int count() const;
signals:
    void countChanged();
private:
    QVector<QString> m_dataSource;
    QVector<int> m_sortedDataIndexes;
};
